Attribute VB_Name = "modTtbCmd"
Option Explicit

Public Declare Function SetWindowLong Lib "user32" Alias _
    "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex _
    As Long, ByVal dwNewLong As Long) As Long

Public Declare Function GetWindowRect Lib "user32" (ByVal _
    hwnd As Long, lpRect As Rect) As Long

Public Declare Function GetParent Lib "user32" (ByVal _
    hwnd As Long) As Long

Public Declare Function SetParent Lib "user32" (ByVal _
    hWndChild As Long, ByVal hWndNewParent As Long) _
    As Long

Public Declare Function SetWindowPos Lib "user32" (ByVal _
    hwnd As Long, ByVal hWndInsertAfter As Long, ByVal _
    x As Long, ByVal y As Long, ByVal cx As Long, _
    ByVal cy As Long, ByVal wFlags As Long) As Long

Public Declare Function SetWindowsHookEx Lib "user32" Alias _
    "SetWindowsHookExA" (ByVal idHook&, ByVal lpfn&, _
    ByVal hmod&, ByVal dwThreadId&) As Long

Public Declare Function UnhookWindowsHookEx Lib "user32" _
    (ByVal hHook&) As Long

Public Type Rect
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type

Public Type CWPSTRUCT
    lParam As Long
    wParam As Long
    Message As Long
    hwnd As Long
End Type

Const WM_COMMAND = &H111
Const WM_NCPAINT = &H85
Const WM_MOVE = &H3
Const SWP_FRAMECHANGED = &H20
Const GWL_EXSTYLE = -20

Private WHook&

Public Function HookProc&(ByVal nCode&, ByVal wParam&, Inf As CWPSTRUCT)
    Dim WinRect As Rect
    
    If Inf.hwnd = GetParent(frmMain.cmdTtbCmd.hwnd) Then
        If Inf.Message = WM_COMMAND Then Call frmMain.cmdTtbCmd_Click
    ElseIf Inf.hwnd = frmMain.hwnd Then
        If Inf.Message = WM_NCPAINT Or Inf.Message = WM_MOVE Then
            Call GetWindowRect(frmMain.hwnd, WinRect)
            Call SetWindowPos(frmMain.cmdTtbCmd.hwnd, 0, WinRect.Right - 85, _
                WinRect.Top + 6, 27, 14, SWP_FRAMECHANGED)
        End If
    End If
End Function

Public Sub Init()
    WHook = SetWindowsHookEx(4, AddressOf HookProc, 0, App.ThreadID)
    Call SetWindowLong(frmMain.cmdTtbCmd.hwnd, GWL_EXSTYLE, &H80)
    Call SetParent(frmMain.cmdTtbCmd.hwnd, GetParent(frmMain.hwnd))
End Sub

Public Sub Terminate()
    Call UnhookWindowsHookEx(WHook)
    Call SetParent(frmMain.cmdTtbCmd.hwnd, frmMain.hwnd)
End Sub
